Subject: [mpls] 答复: Re: [Technical Errata Reported] RFC5884 (5085)

From: <[email-masked]>
Date: Tue, 15 Aug 2017 14:51:13 +0800 (CST)

Hi, I agree with Greg. 

When egress LSR receices the LSP ping echo from ingress LSR, it will send the BFD control packet to establish the BFD session, which could be used to confirm the receving of LSP ping echo request. So It is not necessary for the LSP ping echo reply to report the verification.  I think it is reasonable that the LSP ping echo reply is optional. 

In addition,  it is 7 years since the RFC 5884 was published in 2010.  Vendors may implement the product based on RFC5884.  If we changes the spec, it may bring the compatibility issues.

Regards.

Fangwei.

原始邮件

发件人： <[email-masked]>
收件人： <[email-masked]>
抄送人： <[email-masked]> <[email-masked]> <[email-masked]> <[email-masked]> <[email-masked]>
日 期 ：2017年08月15日 08:18
主 题 ：Re: [mpls] [Technical Errata Reported] RFC5884 (5085)

Greg,

This is my final email on this topic, since the arguments are now just silly and not technically constructive. 

1. It's not about understanding English. It's about understanding specs! The "(if any)" that you quote means there are situations in which there's no echo reply. As I already explained to you, that's for example the case with Reply-mode:  No-reply. However, the "(if any)" does not mean an Echo Reply is OPTIONAL. !! Or that you choose when a reply is not sent!!

2. RFC 8029 obsoleted 4379. But to my recollection, nothing changed relevant to this Errata. 

BFD for MPLS could have updated LSP ping behavior -- it just didn't. 

 Sent from my iPad

 On Aug 14, 2017, at 2:12 PM, Greg Mirsky <[email-masked]> wrote:

Hi Carlos,thank you for sharing your view on how LSP Echo request with BFD Discriminator used to bootstrap a BFD session over MPLS LSP. I'm surprised that you refer to RFC 8029 as normative reference when commenting on RFC 5884. But even if we look into RFC 8029,  it still has the same texts I've quoted in the previous note that suggest that echo reply is optional. Consider one of them "The Sender's Handle is filled in by the sender and returned unchanged by  the receiver in the echo reply (if any)." Though English is my third language, I interpret "if any" in that sentence as clear indication that the echo reply may not be sent ever.

 Regards,
Greg

On Fri, Aug 11, 2017 at 7:45 PM, Carlos Pignataro (cpignata) <[email-masked]> wrote:
 
Jeff, WG,
 I believe there is one additional consideration — please see inline.

 On Aug 11, 2017, at 1:39 PM, Jeffrey Haas <[email-masked]> wrote:
 [Note that I have adjusted the addresses in the headers to try to catch the
 RFC authors' current accounts.]

 The 5884 interop issue keeps bubbling up.  Balaji submitted an errata, which
 provides us with a good place to start technical discussion.
 
 Please note I also spent some time off-list discussing this errata with
 Balaji.

 On Thu, Aug 10, 2017 at 10:35:50PM -0700, RFC Errata System wrote:
 Section: 6
 
 Original Text
 -------------
 The egress LSR MAY respond with an LSP Ping Echo
 reply message that carries the local discriminator assigned by it for
 the BFD session.
 
 Corrected Text
 --------------
 The egress LSR MUST respond with an LSP Ping Echo reply message that
 MAY carry the local discriminator assigned by it for the BFD session.

 Notes
 -----
 It is not clear from the original text which of the following is optional:
  -  The egress MUST send a reply, but the discriminator in the reply is optional
  -  The reply itself is optional
 
 Technically, the reply cannot be optional, because the egress needs to report LSP-Ping verification status to the ingress.

 This is correct — but even more so, technically, it is not up to RFC 5884 to define when an LSP-Ping reply is optional or not.

 That’s’ up to https://tools.ietf.org/html/rfc8029#section-4.4

 Lacking a Reply Mode set to "Do not reply" (https://tools.ietf.org/html/rfc8029#page-12) the RFC 8029 procedures dictate a response be sent, independent of whether the RFC 5884  procedures use that information or not.

 More below.

 The proposed text recommends to include BFD discriminator in the reply. This was the intent of the original text.
 
 My opinion follows:
 
 In section 6 - 
 
 :    On receipt of the LSP Ping Echo request message, the egress LSR MUST
 :    send a BFD Control packet to the ingress LSR, if the validation of
 :    the FEC in the LSP Ping Echo request message succeeds.  This BFD
 :    Control packet MUST set the Your Discriminator field to the
 :    discriminator received from the ingress LSR in the LSP Ping Echo
 :    request message.  The egress LSR MAY respond with an LSP Ping Echo
 :    reply message that carries the local discriminator assigned by it for
 :    the BFD session.  The local discriminator assigned by the egress LSR
 :    MUST be used as the My Discriminator field in the BFD session packets
 :    sent by the egress LSR.
 
 In the text above, I consider it quite clear that the receipt of the BFD
 packet contains sufficient state to bring up the BFD session.  The receipt
 of the same Discriminator in the LSP Ping Echo Reply is optional.
 
 This makes sense partially because the reply may be dropped and we want the
 BFD session to come up as fast as possible.

 Yes, especially because the first sentence says that the egress sending a BFD Control packet implies FEC validation passed. However, https://tools.ietf.org/html/rfc8029#section-4.4 does  more than FEC validation.

 The point of contention appears to be what to do if we *never* get such
 replies.  It's worth pointing out additional text in RFC 5884, section 3.2.
 
 :    Hence, BFD is used in conjunction with LSP Ping for MPLS LSP fault
 :    detection:
 : 
 :       i) LSP Ping is used for bootstrapping the BFD session as described
 :          later in this document.
 : 
 :      ii) BFD is used to exchange fault detection (i.e., BFD session)
 :          packets at the required detection interval.
 : 
 :     iii) LSP Ping is used to periodically verify the control plane
 :          against the data plane by ensuring that the LSP is mapped to
 :          the same FEC, at the egress, as the ingress.
 
 iii above reminds us that the LSP may be torn down because LSP Ping fails.
 Thus, it seems problematic that we do not get a reply ever.
 
 However, with the BFD session in the Up state, we have information proving
 that the LSP is up.  Thus we have contradictory intent.
 
 ---
 
 My opinion is that the MAY in the RFC 5884 procedures is intended to have
 the BFD session come up by the most expedient means.  I do not believe the
 likely intent was to say "don't send Echo Reply".  Among other things, that
 seems contrary to the intent of the general LSP Ping procedures.
 
 Having given my personal observations, we now get to the business of the
 Working Group: Debating intent and related text.  

 My individual opinion is that, as written, RFC 5884 cannot mean any other thing that “ The egress LSR MUST respond with an LSP Ping Echo reply message that
MAY carry the local discriminator assigned by it for the BFD session”.

 In other words, I support this errata.

 This is because RFC 5884 did not update RFC 4379’s procedures. And thus a response is needed based on 8029 irregardless of whether 5884 uses it..

 That said, it is debatable whether that LSP Ping response is useful or not. If it is not sent, it does not comply to 8029. But if the WG wants for it to be not send, a new spec is needed.

 Thanks,

 -- Jeff

—

Carlos Pignataro, [email-masked]
 
 “Sometimes I use big words that I do not fully understand, to make myself sound more photosynthesis."